package de.jjohannes.gradle.javaecosystem.capabilities.rules;

import org.gradle.api.artifacts.CacheableRule;
import org.gradle.api.artifacts.ComponentMetadataContext;
import org.gradle.api.artifacts.ComponentMetadataRule;

@CacheableRule
public abstract class JakartaEjbApiRule implements ComponentMetadataRule {

    public static final String CAPABILITY_GROUP = "javax.ejb";
    public static final String CAPABILITY_NAME = "ejb";

    public static final String[] MODULES = {
            "jakarta.ejb:jakarta.ejb-api",
            "javax.ejb:javax.ejb-api",
            "javax.ejb:ejb-api"
    };

    @Override
    public void execute(ComponentMetadataContext context) {
        String version = context.getDetails().getId().getVersion();
        context.getDetails().allVariants(variant -> variant.withCapabilities(capabilities -> capabilities.addCapability(
            CAPABILITY_GROUP, CAPABILITY_NAME, version
        )));
    }
}
